/********************************************************************************
    Advent of Code 2024 - day-02
********************************************************************************/

package main

import (
	"embed"
	"flag"
	"fmt"
	"log"

	problems "github.com/onyx-and-iris/aoc2024/day-02"
)

//go:embed testdata
var files embed.FS

func main() {
	filename := flag.String("f", "input.txt", "input file")
	flag.Parse()

	data, err := files.ReadFile(fmt.Sprintf("testdata/%s", *filename))
	if err != nil {
		log.Fatal(err)
	}

	one, two, err := problems.Solve(data)
	if err != nil {
		log.Fatal(err)
	}

	fmt.Printf("solution one: %d\nsolution two: %d\n", one, two)
}
